//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1  0
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;  // Time frame to use
extern int    Length          = 25;                 // Main calculation period
extern enPrices Price         = pr_close;           // Price to use
extern double Lambda          = 5;                  // Lambda 
extern bool   alertsOn        = true;               // Turn alerts on
extern bool   alertsOnCurrent = false;              // Alerts on current (still opened) bar?
extern bool   alertsOnSlope   = true;               // Alerts should alert on slope change?
extern bool   alertsOnZeroCross = true;             // Alerts should alert on zero cross?
extern bool   alertsMessage   = true;               // Alerts should show a popup message?
extern bool   alertsSound     = false;              // Alerts hould play a sound?
extern bool   alertsEmail     = true;               // Alerts should send email?
extern bool   alertsNotify    = true;               // Alerts should send notification?
extern bool   Interpolate     = true;               // Interpolate in multi time frame mode?

//
//
//
//
//

double mom[];
double rema[];
double huu[];
double hud[];
double hdd[];
double hdu[];
double slope[];
double cross[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,huu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,hud); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,hdd); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,hdu); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,mom);
      SetIndexBuffer(5,rema);
      SetIndexBuffer(6,slope);
      SetIndexBuffer(7,cross);
         indicatorFileName   = WindowExpertName();
         returnBars          = TimeFrame==-99;
         TimeFrame           = MathMax(TimeFrame,_Period);
         IndicatorShortName(timeFrameToString(TimeFrame)+" Regularized momentum ("+(string)Length+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { huu[0] = limit+1; return(0); }
         if (TimeFrame!=Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  mom[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Lambda,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsEmail,alertsNotify,4,y);
                  huu[i]   = EMPTY_VALUE;
                  hud[i]   = EMPTY_VALUE;
                  hdd[i]   = EMPTY_VALUE;
                  hdu[i]   = EMPTY_VALUE;
                  if (i>=Bars-1) continue;
                  slope[i] = slope[i+1];
                     if (mom[i] > mom[i+1]) slope[i] =  1;
                     if (mom[i] < mom[i+1]) slope[i] = -1;
                     if (slope[i]== 1 && mom[i]>0) huu[i] = mom[i];
                     if (slope[i]==-1 && mom[i]>0) hud[i] = mom[i];
                     if (slope[i]==-1 && mom[i]<0) hdd[i] = mom[i];
                     if (slope[i]== 1 && mom[i]<0) hdu[i] = mom[i];
                     
                     //
                     //
                     //
                     //
                     //
                     
                      if (!Interpolate || (i>0 &&y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                     //
                     //
                     //
                     //
                     //

                     int n,s; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;
                        for(s = 1; (i+n)<Bars && (i+s)<Bars && s < n; s++) 
                        {
  	                        mom[i+s] = mom[i] + (mom[i+n] - mom[i])* s/n;
                              if (huu[i]!=EMPTY_VALUE) huu[i+s] = mom[i+s];
                              if (hud[i]!=EMPTY_VALUE) hud[i+s] = mom[i+s];
                              if (hdu[i]!=EMPTY_VALUE) hdu[i+s] = mom[i+s];
                              if (hdd[i]!=EMPTY_VALUE) hdd[i+s] = mom[i+s];
                        }
            }       
            return(0);
         }

   //
   //
   //
   //
   //

   double alpha = 2.0 / (1.0*Length);      
   double regf1 = (1.0+Lambda*2.0);
   double regf2 = (1.0+Lambda);
   for(i=limit; i>=0; i--) 
   {
      double price = getPrice(Price,Open,Close,High,Low,i);
      if (Bars-i>2)
            rema[i] = (regf1*rema[i+1]+alpha*(price-rema[i+1])-Lambda*rema[i+2])/regf2;
      else  rema[i] = price;
      if (i<Bars-1)
      {
         mom[i]   = (rema[i]-rema[i+1]);
         slope[i] = slope[i+1];
         huu[i]   = EMPTY_VALUE;
         hud[i]   = EMPTY_VALUE;
         hdd[i]   = EMPTY_VALUE;
         hdu[i]   = EMPTY_VALUE;
            if (mom[i] > mom[i+1]) slope[i] =  1;
            if (mom[i] < mom[i+1]) slope[i] = -1;
            if (slope[i]== 1 && mom[i]>0) huu[i] = mom[i];
            if (slope[i]==-1 && mom[i]>0) hud[i] = mom[i];
            if (slope[i]==-1 && mom[i]<0) hdd[i] = mom[i];
            if (slope[i]== 1 && mom[i]<0) hdu[i] = mom[i];
            cross[i] = cross[i+1];
               if (mom[i]>0) cross[i] =  1;
               if (mom[i]<0) cross[i] = -1;
      }               
   }   
   
   //
   //
   //
   //
   //
    
   if (alertsOn)
   {
     int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
     if (alertsOnSlope)
      {
         static string   mess1 = "";
         static datetime time1 = 0;      
            if (huu[whichBar+1] == EMPTY_VALUE && huu[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping up and greater than zero");
            if (hud[whichBar+1] == EMPTY_VALUE && hud[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping down and greater than zero");
            if (hdd[whichBar+1] == EMPTY_VALUE && hdd[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping down and less than zero");
            if (hdu[whichBar+1] == EMPTY_VALUE && hdu[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping up and less than zero");
      }
      if (alertsOnZeroCross)
      {
         static string   mess2 = "";
         static datetime time2 = 0;      
         if (cross[whichBar]!=cross[whichBar+1])
         {            
            if (cross[whichBar] ==  1) doAlert(mess2,time2,whichBar,"zero line crossed up");
            if (cross[whichBar] == -1) doAlert(mess2,time2,whichBar,"zero line crossed down");
         }            
      }         
    }            
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Regularized momentum ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Regularized momentum "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}